require 'agenda/repetition'
# require 'kero/testing'

raise "testing foundation unavailable, move to TestUnit, UnitTest, RUnit or whatever"

=begin
Run all kinds of tests, which should succeed, to know there are very few errors.
=end
module Agenda
  def Agenda::test_TimeOrdering
    before = Time.local(2000, 12, 21, 16, 16, 59, 0)
    after = Time.local(2000, 12, 21, 16, 18, 29, 0)
    (before + 90 < after) and (before + 91 > after)
  end

  puts "All tests involve Repeating, but should use Repetition"
  exit 1

  @now = Time.now()

  def Agenda::test_ZeroLengthRepeat
    rep = Repeating.new(@now, 0, 20, 60, "length zero appt")
    occ = rep.match(TimeInterval.new(@now, 40))
    (occ.length == 2)
  end

  def Agenda::test_TouchingIntervalBefore
    rep = Repeating.new(@now, Hour, Day, Week, "hourly, each day for one week")
    occ = rep.match(TimeInterval.new(@now-Day, Day))
    (occ.length == 0)
  end

  def Agenda::test_OnEdgeBegin
    rep = Repeating.new(@now, Hour, Day, 300*Day, "regular")
    occ = rep.match(TimeInterval.new(@now-5*Day, 16*Day))
    (occ.length == 11)
  end

  def Agenda::test_Within
    rep = Repeating.new(@now, Hour, Day, 300*Day, "regular")
    occ = rep.match(TimeInterval.new(@now+5*Day, 16*Day))
    (occ.length == 16)
  end

  def Agenda::test_Surround
    rep = Repeating.new(@now, Hour, Day, Week, "regular")
    occ = rep.match(TimeInterval.new(@now-5*Day, 16*Day))
    (occ.length == 7)
  end

  def Agenda::test_OnEdgeAfter
    rep = Repeating.new(@now, Hour, Day, Week, "regular")
    occ = rep.match(TimeInterval.new(@now+5*Day, 16*Day))
    (occ.length == 2)
  end

  def Agenda::test_TouchingIntervalAfter
    rep = Repeating.new(@now, Hour, Day, Week, "hour, daily for one week")
    occ = rep.match(TimeInterval.new(@now+Week, Day))
    (occ.length == 0)
  end

  def Agenda::test_OpenEnding
    rep = Repeating.new(@now, Hour, Day, OpenRepetition, "hour, daily forever")
    occ = rep.match(TimeInterval.new(@now+Week, Week))
    (occ.length == 7)
  end

  # runTests()
end
